Subject: Re: [PATCH] add GIT_FAST_STAT mode for Cygwin

From: "Shawn O. Pearce" <[email-masked]>
Date: Tue, 23 Sep 2008 12:06:37 -0700

Dmitry Potapov <[email-masked]> wrote:
> On Tue, Sep 23, 2008 at 08:31:48AM -0700, Shawn O. Pearce wrote:
> > 
> > I wonder, should this be controlled by an environment variable?
> > 
> > Given your description of the feature it seems to be more a property
> > of the specific repository, as it is based upon where the repository
> > lives within the Cygwin namespace.  Should this be controlled instead
> > by say a "core.cygwinnativestat = true" configuration property?
> 
> I am not sure that you will find many people who will want to set this
> option per repository, yet Git has the configuration file, and I agree
> it is better to place it there.

If you want it globally you can do:

  git config --global core.cygwinnativestat true

and then disable it on a per-repository basis if you and a specific
repository which has this inner mount problem:

  git config core.cygwinnativestat false

Which is a lot more powerful than an environment variable.
 
> However, this option is Cygwin specific, so I am not sure where it
> should be read. Should I place it in git_default_core_config like
> this:
> 
> #ifdef __CYGWIN__
> 	if (!strcmp(var, "core.cygwinnativestat")) {
> 		cygwin_native_stat = git_config_bool(var, value);
> 		return 0;
> 	}
> #endif

I would have the two initial stat functions swap themselves out with
the default Cygin stat implementations, run a parse over the config
to load that one bool, then install the proper implementations based
upon its value.  Hence all Cygwin code is kept inside of the Cygwin
compat code, and no #ifdef is necessary

Of course that config file parse can only happen after the repository
has been entered, which means you need to somehow rely on the real
Cygwin stat functions until setup_git_directory() has completed,
and then on the next stat call (re)parse the config and swap the
implementation.

-- 
Shawn.